#include <malloc.h>
#include "debug.h"

#define D_WIDTH   300
#define D_HEIGHT  100

Debug::Debug() : Label()
{
}

Debug::~Debug()
{
}

uint32_t Debug::outputMemory(void)
{
	uint32_t x = 1024;
	void *mem = NULL;
	
    /* Try to allocate more until we run out */
	while( (mem = malloc(x)) )
	{
		free(mem);
		x += 1024;
	}
	
    return x;
}


void Debug::draw()
{	
    // Ensure proper size
    if( _rect.width != D_WIDTH && _rect.height != D_HEIGHT )
    {
        resize( D_WIDTH, D_HEIGHT );
    }
    
    // Draw on relevant text
#ifdef DEBUG_MODE
    char tStr[4096];
    sprintf( tStr, "Current buffer: %d\n%d < %d < %d\n\nFile pos %d of max %d\nMemory available %d",
                   sound.getCurrentParameter( 0 ), sound.getCurrentParameter( 1 ),
                   sound.getCurrentParameter( 2 ), sound.getCurrentParameter( 3 ),
                   file.getCurrentParameter( 0 ), file.getCurrentParameter( 1 ),
                   outputMemory() );

    setCaption( tStr );
#else
    setCaption( "HOW DID THIS GET HERE I AM NOT GOOD WITH COMPUTER!" );
#endif
    
    // Draw using label's old
    Label::draw();
}
