#ifndef __GMESOURCE_H
#define __GMESOURCE_H

#ifdef __cplusplus
extern "C" {
#endif

#include <gme/gme.h>

#include "soundsource.h"

class GmeSource : public SoundSource
{
	public:
		GmeSource();
		virtual ~GmeSource();
		
		virtual OpenStatus openLocation(File *sourceFile);
		virtual int renderChunk(uint8_t *buf, int &renderSamples);
		virtual void seekSeconds(int seconds);
		virtual int tellSeconds();
		virtual int getLength();
		virtual uint32_t getFrequency();
		virtual void close();
		
		virtual int supportsFormat(const char *ext);
		virtual bool hasTime();
	private:
		Music_Emu* emu;
		
		int track_count;
		int track;
};

#ifdef __cplusplus
}
#endif

#endif
