#include <string.h>
#include "language.h"

char Language::_language[LANGUAGE_STRINGS_COUNT][MAX_STRING_LENGTH] = { { 0 } };

Language::Language()
{	
	// Remember that this is theme
	whichVars = 2;
	
	if(!_instance[whichVars])
	{
		// Ensure document pointer is null
		_document[whichVars] = NULL;
		
		// Ensure no invalid path
		skinPath[whichVars][0] = 0;
	}
	
	// Keep track of copies
	_instance[whichVars]++;
}

void Language::setDefault()
{
	strcpy(_language[LANGUAGE_ON], "On");
	strcpy(_language[LANGUAGE_OFF], "Off");
	strcpy(_language[LANGUAGE_NOTHING], "Nothing!");
	strcpy(_language[LANGUAGE_UP], "Up");
	strcpy(_language[LANGUAGE_DOWN], "Down");
	strcpy(_language[LANGUAGE_LEFT], "Left");
	strcpy(_language[LANGUAGE_RIGHT], "Right");
	strcpy(_language[LANGUAGE_HOME_MESSAGE], "Press HOME to close.");
	strcpy(_language[LANGUAGE_EXIT], "Exit DMP");
	strcpy(_language[LANGUAGE_CLOSE], "Close Menu");
	strcpy(_language[LANGUAGE_LIGHT_SETTING], "Wii light flash");
	strcpy(_language[LANGUAGE_SCREEN_SETTING], "Screen position");
	strcpy(_language[LANGUAGE_THEME_SETTING], "Theme");
	strcat(_language[LANGUAGE_THEME_SETTING], ":");
	strcpy(_language[LANGUAGE_LANGUAGE_SETTING], "Language");
	strcat(_language[LANGUAGE_LANGUAGE_SETTING], ":");
	strcpy(_language[LANGUAGE_RANDOM], "Random play");
	strcpy(_language[LANGUAGE_SEQUENTIAL], "Sequential play");
	strcpy(_language[LANGUAGE_REPEAT], "Repeat play");
}

int Language::loadLanguage(const char *url)
{
	// Ensure SOME language
	setDefault();
	
	// Wrapper to make things readable
	if(loadTheme(url)) { return -1; }
	
	// Grab individual language strings
	Theme::getString("DriveLight.Setting", _language[LANGUAGE_LIGHT_SETTING], _language[LANGUAGE_LIGHT_SETTING]);
	Theme::getString("DriveLight.On", _language[LANGUAGE_ON], _language[LANGUAGE_ON]);
	Theme::getString("DriveLight.Off", _language[LANGUAGE_OFF], _language[LANGUAGE_OFF]);
	
	Theme::getString("Screen.Setting", _language[LANGUAGE_SCREEN_SETTING], _language[LANGUAGE_SCREEN_SETTING]);
	Theme::getString("Screen.Up", _language[LANGUAGE_UP], _language[LANGUAGE_UP]);
	Theme::getString("Screen.Down", _language[LANGUAGE_DOWN], _language[LANGUAGE_DOWN]);
	Theme::getString("Screen.Left", _language[LANGUAGE_LEFT], _language[LANGUAGE_LEFT]);
	Theme::getString("Screen.Right", _language[LANGUAGE_RIGHT], _language[LANGUAGE_RIGHT]);
	
	Theme::getString("Theme.Setting", _language[LANGUAGE_THEME_SETTING], _language[LANGUAGE_THEME_SETTING]);
	
	// Ensure colon
	if(_language[LANGUAGE_THEME_SETTING][strlen(_language[LANGUAGE_THEME_SETTING]) - 1] != ':')
	{
		strcat(_language[LANGUAGE_THEME_SETTING], ":");
	}
	
	Theme::getString("Language.Setting", _language[LANGUAGE_LANGUAGE_SETTING], _language[LANGUAGE_LANGUAGE_SETTING]);
	
	// Ensure colon
	if(_language[LANGUAGE_LANGUAGE_SETTING][strlen(_language[LANGUAGE_LANGUAGE_SETTING]) - 1] != ':')
	{
		strcat(_language[LANGUAGE_LANGUAGE_SETTING], ":");
	}
	
	Theme::getString("Random", _language[LANGUAGE_RANDOM], _language[LANGUAGE_RANDOM]);
	Theme::getString("Sequential", _language[LANGUAGE_SEQUENTIAL], _language[LANGUAGE_SEQUENTIAL]);
	Theme::getString("Repeat", _language[LANGUAGE_REPEAT], _language[LANGUAGE_REPEAT]);
	Theme::getString("Nothing", _language[LANGUAGE_NOTHING], _language[LANGUAGE_NOTHING]);
	
	Theme::getString("Home.Message", _language[LANGUAGE_HOME_MESSAGE], _language[LANGUAGE_HOME_MESSAGE]);
	Theme::getString("Home.Close", _language[LANGUAGE_CLOSE], _language[LANGUAGE_CLOSE]);
	Theme::getString("Home.Exit", _language[LANGUAGE_EXIT], _language[LANGUAGE_EXIT]);
	
	// Great success ^^;
	return 0;
}

char *Language::getString(LanguageIdentifier str_const)
{
	return _language[str_const];
}
