#ifndef __LANGUAGE_H
#define __LANGUAGE_H

#ifdef __cplusplus
extern "C" {
#endif
#include "theme.h"

#define MAX_STRING_LENGTH	1024

typedef enum
{
	LANGUAGE_ON,
	LANGUAGE_OFF,
	LANGUAGE_NOTHING,
	LANGUAGE_UP,
	LANGUAGE_DOWN,
	LANGUAGE_LEFT,
	LANGUAGE_RIGHT,
	LANGUAGE_HOME_MESSAGE,
	LANGUAGE_EXIT,
	LANGUAGE_CLOSE,
	LANGUAGE_LIGHT_SETTING,
	LANGUAGE_SCREEN_SETTING,
	LANGUAGE_THEME_SETTING,
	LANGUAGE_LANGUAGE_SETTING,
	LANGUAGE_RANDOM,
	LANGUAGE_SEQUENTIAL,
	LANGUAGE_REPEAT,
	LANGUAGE_STRINGS_COUNT
} LanguageIdentifier;

class Language : public Theme
{
	public:
		Language();
		
		int loadLanguage(const char *url);
		
		char *getString(LanguageIdentifier str_const);
	private:
		void setDefault();
		
		static char _language[LANGUAGE_STRINGS_COUNT][MAX_STRING_LENGTH];
};

#ifdef __cplusplus
}
#endif

#endif
