#ifndef __PLAYLIST_H
#define __PLAYLIST_H

#ifdef __cplusplus
extern "C" {
#endif

#include "file.h"

typedef struct
{
	char *descriptionEntry;
	char *urlEntry;
} PlsType;

class Playlist
{
	public:
		Playlist();
		~Playlist();
		
		int open(const char *url);
		int findNextEntry(char *fileName, char *displayName, FileType &f);
		void close();
	private:
		void fillBlanks();
		bool loadM3U(const char *fName);
		bool loadPlaylist(const char *fName);
		
		PlsType *entries;
		int numEntries;
		
		int curEntry;
};

#ifdef __cplusplus
}
#endif

#endif


