#ifndef __SIDSOURCE_H
#define __SIDSOURCE_H

#ifdef __cplusplus
extern "C" {
#endif

#include "soundsource.h"

class SidSource : public SoundSource
{
	public:
		SidSource();
		virtual ~SidSource();
		
		virtual OpenStatus openLocation(File *sourceFile);
		virtual int renderChunk(uint8_t *buf, int &renderSamples);
		virtual void seekSeconds(int seconds);
		virtual int tellSeconds();
		virtual int getLength();
		virtual uint32_t getFrequency();
		virtual void close();
		
		virtual int supportsFormat(const char *ext);
		virtual bool hasTime();
	private:
		void *buffer;
		
		unsigned char track;
		unsigned char track_count;
		unsigned char play_speed;
		
		unsigned short sid_load_addr;
		unsigned short sid_init_addr;
		unsigned short sid_play_addr;
		
		int nSamplesPerCall;
		int nSamplesToRender;
};

#ifdef __cplusplus
}
#endif

#endif
