#ifndef __SNDHSOURCE_H
#define __SNDHSOURCE_H

#ifdef __cplusplus
extern "C" {
#endif

#include <api68/api68.h>

#include "soundsource.h"

class SndhSource : public SoundSource
{
	public:
		SndhSource();
		virtual ~SndhSource();
		
		virtual OpenStatus openLocation(File *sourceFile);
		virtual int renderChunk(uint8_t *buf, int &renderSamples);
		virtual void seekSeconds(int seconds);
		virtual int tellSeconds();
		virtual int getLength();
		virtual uint32_t getFrequency();
		virtual void close();
		
		virtual int supportsFormat(const char *ext);
		virtual bool hasTime();
	private:
		void *buffer;
		
		api68_init_t init68;
		api68_t *sc68;
		
		int track_count;
		int track;
};

#ifdef __cplusplus
}
#endif

#endif
